com.r3corda.protocols / TwoPartyTradeProtocol / Buyer

# Buyer

`class Buyer : ProtocolLogic<SignedTransaction>`

### Types

RECEIVING | `object RECEIVING : Step`
SIGNING | `object SIGNING : Step`
SWAPPING_SIGNATURES | `object SWAPPING_SIGNATURES : Step`
VERIFYING | `object VERIFYING : Step`

### Constructors

<init> | `Buyer(otherSide: SingleMessageRecipient, notary: Party, acceptablePrice: Amount<Currency>, typeToBuy: Class<out OwnableState>, sessionID: Long)`

### Properties

acceptablePrice | `val acceptablePrice: Amount<Currency>`
notary | `val notary: Party`
otherSide | `val otherSide: SingleMessageRecipient`
progressTracker | `open val progressTracker: ProgressTracker` Override this to provide a ProgressTracker. If one is provided and stepped, the framework will do something helpful with the progress reports. If this protocol is invoked as a sub-protocol of another, then the tracker will be made a child of the current step in the parent. If its null, this protocol doesnt track progress.
sessionID | `val sessionID: Long`
typeToBuy | `val typeToBuy: Class<out OwnableState>`

### Inherited Properties

logger | `val logger: <ERROR CLASS>` This is where you should log things to.
psm | `lateinit var psm: ProtocolStateMachine<*>` Reference to the Fiber instance that is the top level controller for the entire flow.
serviceHub | `val serviceHub: ServiceHub` Provides access to big, heavy classes that may be reconstructed from time to time, e.g. across restarts

### Functions

call | `open fun call(): SignedTransaction` This is where you fill out your business logic.

### Inherited Functions

receive | `fun <T : Any> receive(topic: String, sessionIDForReceive: Long, clazz: Class<T>): UntrustworthyData<T>` `fun <T : Any> receive(topic: String, sessionIDForReceive: Long): UntrustworthyData<T>`
send | `fun send(topic: String, destination: MessageRecipients, sessionID: Long, obj: Any): Unit`
sendAndReceive | `fun <T : Any> sendAndReceive(topic: String, destination: MessageRecipients, sessionIDForSend: Long, sessionIDForReceive: Long, obj: Any): UntrustworthyData<T>`
subProtocol | `fun <R> subProtocol(subLogic: ProtocolLogic<R>): R` Invokes the given subprotocol by simply passing through this ProtocolLogics reference to the ProtocolStateMachine and then calling the call method.